import Control.Concurrent
import Queue

test1 :: IO ()
test1 = do
  q <- newQueue
  writeQueue q 1
  writeQueue q 2
  writeQueue q 3
  taskDone q
  taskDone q
  taskDone q
  joinQueue q
  putStrLn "test1 done."

test2 :: IO ()
test2 = do
  q <- newQueue
  writeQueue q 1
  writeQueue q 2
  writeQueue q 3
  taskDone q
  taskDone q
  forkIO $ do
          threadDelay (5 * 1000000)
          taskDone q
  joinQueue q
  putStrLn "test2 done."

main :: IO ()
main = do
  test1
  test2
